> ## Documentation Index
> Fetch the complete documentation index at: https://docs.runaether.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Pin a task



## OpenAPI

````yaml api-reference/openapi.v1.json POST /tasks/{taskID}/pin
openapi: 3.1.0
info:
  title: Aether Public API
  version: 0.1.0
  description: >-
    The versioned, public Aether REST API. Authenticate with an `aether_`
    platform API key or a session token.
servers:
  - url: https://api.runaether.dev/v1
security:
  - bearerAuth: []
paths:
  /tasks/{taskID}/pin:
    post:
      tags:
        - tasks
      summary: Pin a task
      operationId: pinTask
      parameters:
        - in: path
          name: taskID
          required: true
          schema:
            format: uuid
            pattern: ^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                discriminator:
                  mapping:
                    awaiting_input: '#/components/schemas/TaskAwaitingInputWithActivity'
                    errored: '#/components/schemas/TaskErroredWithActivity'
                    processing: '#/components/schemas/TaskProcessingWithActivity'
                    queued: '#/components/schemas/TaskQueuedWithActivity'
                  propertyName: status
                oneOf:
                  - $ref: '#/components/schemas/TaskQueuedWithActivity'
                  - $ref: '#/components/schemas/TaskProcessingWithActivity'
                  - $ref: '#/components/schemas/TaskAwaitingInputWithActivity'
                  - $ref: '#/components/schemas/TaskErroredWithActivity'
          description: OK
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OrgAuthorizationErrorResponse'
          description: Forbidden
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Not Found
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unprocessable Entity
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Internal Server Error
        '503':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Service Unavailable
components:
  schemas:
    TaskAwaitingInputWithActivity:
      additionalProperties: false
      properties:
        activity_items:
          items:
            $ref: '#/components/schemas/TaskActivityItem'
          type: array
        agent_segments:
          items:
            $ref: '#/components/schemas/TaskAgentSegment'
          type: array
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        awaiting_input:
          $ref: '#/components/schemas/TaskAwaitingInputPayload'
        base_branch:
          minLength: 1
          pattern: \S
          type: string
        campaign:
          anyOf:
            - $ref: '#/components/schemas/TaskCampaignSummary'
            - type: 'null'
        created_at:
          minLength: 1
          type: string
        creator_reauth_required:
          type: boolean
        display_status:
          enum:
            - running
            - awaiting_input
            - approved
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        github_status:
          enum:
            - approved
            - merged
            - unmerged
            - awaiting_ci
          type:
            - string
            - 'null'
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        latest_message_revision:
          description: >-
            Maximum revision_sequence of currently stored task messages,
            including soft-deleted rows; zero means no messages. Compare
            equality only: hard deletion can decrease it. Not an activity/stream
            cursor or a task-wide version.
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        latest_workspace_warning:
          minLength: 1
          type: string
        mcp_servers:
          items:
            $ref: '#/components/schemas/TaskMcpServer'
          type: array
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        parent_task_id:
          format: uuid
          type:
            - string
            - 'null'
        pinned_at:
          minLength: 1
          type:
            - string
            - 'null'
        plan:
          $ref: '#/components/schemas/TaskPlan'
        plan_progress:
          $ref: '#/components/schemas/TaskPlanProgress'
        post_pr_demo_video:
          type: boolean
        post_pr_screenshots:
          type: boolean
        pr_review_mode:
          enum:
            - review_only
            - fix_on_request
            - apply_fixes
          type:
            - string
            - 'null'
        pr_review_summary:
          anyOf:
            - $ref: '#/components/schemas/TaskPRReviewSummary'
            - type: 'null'
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project:
          $ref: '#/components/schemas/TaskProjectContext'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        repo_mcp_server_notes:
          items:
            minLength: 1
            type: string
          type: array
        repo_mcp_server_skips:
          items:
            $ref: '#/components/schemas/RepoMcpServerSkip'
          type: array
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_intervals:
          items:
            $ref: '#/components/schemas/TaskRuntimeInterval'
          type: array
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - awaiting_input
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - id
        - project_id
        - project
        - parent_task_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - post_pr_screenshots
        - post_pr_demo_video
        - status
        - display_status
        - github_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - pr_review_summary
        - campaign
        - creator_reauth_required
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - base_branch
        - latest_message_revision
        - run_context
        - awaiting_input
        - activity_items
        - mcp_servers
        - repo_mcp_server_notes
        - repo_mcp_server_skips
      type: object
    TaskErroredWithActivity:
      additionalProperties: false
      properties:
        activity_items:
          items:
            $ref: '#/components/schemas/TaskActivityItem'
          type: array
        agent_segments:
          items:
            $ref: '#/components/schemas/TaskAgentSegment'
          type: array
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        base_branch:
          minLength: 1
          pattern: \S
          type: string
        campaign:
          anyOf:
            - $ref: '#/components/schemas/TaskCampaignSummary'
            - type: 'null'
        completed_at:
          minLength: 1
          type: string
        created_at:
          minLength: 1
          type: string
        creator_reauth_required:
          type: boolean
        display_status:
          enum:
            - running
            - awaiting_input
            - approved
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        error:
          minLength: 1
          type: string
        failure:
          $ref: '#/components/schemas/TaskFailure'
        feed_updated_at:
          minLength: 1
          type: string
        github_status:
          enum:
            - approved
            - merged
            - unmerged
            - awaiting_ci
          type:
            - string
            - 'null'
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        latest_message_revision:
          description: >-
            Maximum revision_sequence of currently stored task messages,
            including soft-deleted rows; zero means no messages. Compare
            equality only: hard deletion can decrease it. Not an activity/stream
            cursor or a task-wide version.
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        latest_workspace_warning:
          minLength: 1
          type: string
        mcp_servers:
          items:
            $ref: '#/components/schemas/TaskMcpServer'
          type: array
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        parent_task_id:
          format: uuid
          type:
            - string
            - 'null'
        pinned_at:
          minLength: 1
          type:
            - string
            - 'null'
        plan:
          $ref: '#/components/schemas/TaskPlan'
        plan_progress:
          $ref: '#/components/schemas/TaskPlanProgress'
        post_pr_demo_video:
          type: boolean
        post_pr_screenshots:
          type: boolean
        pr_review_mode:
          enum:
            - review_only
            - fix_on_request
            - apply_fixes
          type:
            - string
            - 'null'
        pr_review_summary:
          anyOf:
            - $ref: '#/components/schemas/TaskPRReviewSummary'
            - type: 'null'
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project:
          $ref: '#/components/schemas/TaskProjectContext'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        repo_mcp_server_notes:
          items:
            minLength: 1
            type: string
          type: array
        repo_mcp_server_skips:
          items:
            $ref: '#/components/schemas/RepoMcpServerSkip'
          type: array
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_intervals:
          items:
            $ref: '#/components/schemas/TaskRuntimeInterval'
          type: array
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - errored
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - id
        - project_id
        - project
        - parent_task_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - post_pr_screenshots
        - post_pr_demo_video
        - status
        - display_status
        - github_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - pr_review_summary
        - campaign
        - creator_reauth_required
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - base_branch
        - latest_message_revision
        - run_context
        - error
        - completed_at
        - activity_items
        - mcp_servers
        - repo_mcp_server_notes
        - repo_mcp_server_skips
      type: object
    TaskProcessingWithActivity:
      additionalProperties: false
      properties:
        activity_items:
          items:
            $ref: '#/components/schemas/TaskActivityItem'
          type: array
        agent_segments:
          items:
            $ref: '#/components/schemas/TaskAgentSegment'
          type: array
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        base_branch:
          minLength: 1
          pattern: \S
          type: string
        campaign:
          anyOf:
            - $ref: '#/components/schemas/TaskCampaignSummary'
            - type: 'null'
        created_at:
          minLength: 1
          type: string
        creator_reauth_required:
          type: boolean
        display_status:
          enum:
            - running
            - awaiting_input
            - approved
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        github_status:
          enum:
            - approved
            - merged
            - unmerged
            - awaiting_ci
          type:
            - string
            - 'null'
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        latest_message_revision:
          description: >-
            Maximum revision_sequence of currently stored task messages,
            including soft-deleted rows; zero means no messages. Compare
            equality only: hard deletion can decrease it. Not an activity/stream
            cursor or a task-wide version.
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        latest_workspace_warning:
          minLength: 1
          type: string
        mcp_servers:
          items:
            $ref: '#/components/schemas/TaskMcpServer'
          type: array
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        parent_task_id:
          format: uuid
          type:
            - string
            - 'null'
        pinned_at:
          minLength: 1
          type:
            - string
            - 'null'
        plan:
          $ref: '#/components/schemas/TaskPlan'
        plan_progress:
          $ref: '#/components/schemas/TaskPlanProgress'
        post_pr_demo_video:
          type: boolean
        post_pr_screenshots:
          type: boolean
        pr_review_mode:
          enum:
            - review_only
            - fix_on_request
            - apply_fixes
          type:
            - string
            - 'null'
        pr_review_summary:
          anyOf:
            - $ref: '#/components/schemas/TaskPRReviewSummary'
            - type: 'null'
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project:
          $ref: '#/components/schemas/TaskProjectContext'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        repo_mcp_server_notes:
          items:
            minLength: 1
            type: string
          type: array
        repo_mcp_server_skips:
          items:
            $ref: '#/components/schemas/RepoMcpServerSkip'
          type: array
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          $ref: '#/components/schemas/TaskRunContext'
        runtime_intervals:
          items:
            $ref: '#/components/schemas/TaskRuntimeInterval'
          type: array
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - processing
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - id
        - project_id
        - project
        - parent_task_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - post_pr_screenshots
        - post_pr_demo_video
        - status
        - display_status
        - github_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - pr_review_summary
        - campaign
        - creator_reauth_required
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - base_branch
        - latest_message_revision
        - run_context
        - activity_items
        - mcp_servers
        - repo_mcp_server_notes
        - repo_mcp_server_skips
      type: object
    TaskQueuedWithActivity:
      additionalProperties: false
      properties:
        activity_items:
          items:
            $ref: '#/components/schemas/TaskActivityItem'
          type: array
        agent_segments:
          items:
            $ref: '#/components/schemas/TaskAgentSegment'
          type: array
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        base_branch:
          minLength: 1
          pattern: \S
          type: string
        campaign:
          anyOf:
            - $ref: '#/components/schemas/TaskCampaignSummary'
            - type: 'null'
        created_at:
          minLength: 1
          type: string
        creator_reauth_required:
          type: boolean
        display_status:
          enum:
            - running
            - awaiting_input
            - approved
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        github_status:
          enum:
            - approved
            - merged
            - unmerged
            - awaiting_ci
          type:
            - string
            - 'null'
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        latest_message_revision:
          description: >-
            Maximum revision_sequence of currently stored task messages,
            including soft-deleted rows; zero means no messages. Compare
            equality only: hard deletion can decrease it. Not an activity/stream
            cursor or a task-wide version.
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        latest_workspace_warning:
          minLength: 1
          type: string
        mcp_servers:
          items:
            $ref: '#/components/schemas/TaskMcpServer'
          type: array
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        parent_task_id:
          format: uuid
          type:
            - string
            - 'null'
        pinned_at:
          minLength: 1
          type:
            - string
            - 'null'
        plan:
          $ref: '#/components/schemas/TaskPlan'
        plan_progress:
          $ref: '#/components/schemas/TaskPlanProgress'
        post_pr_demo_video:
          type: boolean
        post_pr_screenshots:
          type: boolean
        pr_review_mode:
          enum:
            - review_only
            - fix_on_request
            - apply_fixes
          type:
            - string
            - 'null'
        pr_review_summary:
          anyOf:
            - $ref: '#/components/schemas/TaskPRReviewSummary'
            - type: 'null'
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project:
          $ref: '#/components/schemas/TaskProjectContext'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        repo_mcp_server_notes:
          items:
            minLength: 1
            type: string
          type: array
        repo_mcp_server_skips:
          items:
            $ref: '#/components/schemas/RepoMcpServerSkip'
          type: array
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_intervals:
          items:
            $ref: '#/components/schemas/TaskRuntimeInterval'
          type: array
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - queued
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - id
        - project_id
        - project
        - parent_task_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - post_pr_screenshots
        - post_pr_demo_video
        - status
        - display_status
        - github_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - pr_review_summary
        - campaign
        - creator_reauth_required
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - base_branch
        - latest_message_revision
        - run_context
        - activity_items
        - mcp_servers
        - repo_mcp_server_notes
        - repo_mcp_server_skips
      type: object
    ErrorResponse:
      additionalProperties: false
      properties:
        code:
          type: string
        error:
          minLength: 1
          type: string
        errors:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
      required:
        - error
      type: object
    OrgAuthorizationErrorResponse:
      additionalProperties: false
      properties:
        code:
          enum:
            - org_membership_required
            - org_role_insufficient
            - org_suspended
            - account_deleting
          type: string
        error:
          minLength: 1
          type: string
      required:
        - error
        - code
      type: object
    TaskActivityItem:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        message:
          minLength: 1
          pattern: \S
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - done
            - error
            - question
            - stop
            - workspace_lifecycle
            - workspace_warning
            - ci_passed
            - ci_failed
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - message
      type: object
    TaskAgentSegment:
      additionalProperties: false
      properties:
        end_reason:
          enum:
            - completed
            - awaiting_input
            - errored
            - interrupted
          type:
            - string
            - 'null'
        ended_at:
          minLength: 1
          type:
            - string
            - 'null'
        id:
          minLength: 1
          type: string
        started_at:
          minLength: 1
          type: string
        task_id:
          minLength: 1
          type: string
        tokens_in:
          format: int64
          minimum: 0
          type: integer
        tokens_out:
          format: int64
          minimum: 0
          type: integer
      required:
        - id
        - task_id
        - started_at
        - tokens_in
        - tokens_out
      type: object
    TaskAwaitingInputPayload:
      discriminator:
        mapping:
          message: '#/components/schemas/TaskAwaitingInputMessage'
          plan: '#/components/schemas/TaskAwaitingInputPlan'
          questions: '#/components/schemas/TaskAwaitingInputQuestions'
        propertyName: kind
      oneOf:
        - $ref: '#/components/schemas/TaskAwaitingInputMessage'
        - $ref: '#/components/schemas/TaskAwaitingInputQuestions'
        - $ref: '#/components/schemas/TaskAwaitingInputPlan'
    TaskCampaignSummary:
      additionalProperties: false
      properties:
        active_descendants:
          format: int64
          minimum: 0
          type: integer
        attention:
          enum:
            - error
            - waiting
          type:
            - string
            - 'null'
        descendants_merged:
          format: int64
          minimum: 0
          type: integer
        descendants_total:
          format: int64
          minimum: 1
          type: integer
      required:
        - descendants_total
        - descendants_merged
        - active_descendants
        - attention
      type: object
    HardwareConfig:
      additionalProperties: false
      properties:
        cpu_kind:
          enum:
            - shared
            - performance
          type: string
        cpus:
          format: int64
          maximum: 16
          minimum: 1
          type: integer
        gpu_kind:
          enum:
            - a10
            - l40s
            - a100-40gb
            - a100-80gb
          type:
            - string
            - 'null'
        memory_mb:
          format: int64
          maximum: 32768
          minimum: 256
          type: integer
        volume_size_gb:
          format: int64
          maximum: 500
          minimum: 1
          type: integer
      required:
        - cpu_kind
        - cpus
        - memory_mb
        - volume_size_gb
        - gpu_kind
      type: object
    TaskMcpServer:
      discriminator:
        mapping:
          catalog: '#/components/schemas/TaskMcpCatalogServer'
          repo: '#/components/schemas/TaskMcpRepoServer'
        propertyName: source
      oneOf:
        - $ref: '#/components/schemas/TaskMcpCatalogServer'
        - $ref: '#/components/schemas/TaskMcpRepoServer'
    TaskPlan:
      additionalProperties: false
      properties:
        completed:
          format: int64
          minimum: 0
          type: integer
        current_step:
          minLength: 1
          pattern: \S
          type: string
        explanation:
          minLength: 1
          pattern: \S
          type: string
        steps:
          items:
            $ref: '#/components/schemas/TaskPlanStep'
          type: array
        total:
          format: int64
          minimum: 1
          type: integer
        updated_at:
          minLength: 1
          type: string
      required:
        - steps
        - completed
        - total
        - updated_at
      type: object
    TaskPlanProgress:
      additionalProperties: false
      properties:
        completed:
          format: int64
          minimum: 0
          type: integer
        current_step:
          minLength: 1
          pattern: \S
          type: string
        total:
          format: int64
          minimum: 1
          type: integer
      required:
        - completed
        - total
      type: object
    TaskPRReviewSummary:
      additionalProperties: false
      properties:
        comment_count:
          format: int64
          minimum: 0
          type:
            - integer
            - 'null'
        pull_request_id:
          format: uuid
          type: string
        review_task_id:
          format: uuid
          type: string
        run_count:
          format: int64
          minimum: 1
          type: integer
        run_status:
          $ref: '#/components/schemas/ReviewRunStatus'
        severity_counts:
          $ref: '#/components/schemas/PRReviewSeverityCounts'
        summary_severity:
          $ref: '#/components/schemas/PRReviewSummarySeverity'
        verdict:
          $ref: '#/components/schemas/PRReviewSummaryVerdict'
      required:
        - review_task_id
        - pull_request_id
        - run_status
        - comment_count
        - run_count
      type: object
    TaskPullRequest:
      additionalProperties: false
      properties:
        additions:
          format: int64
          minimum: 0
          type: integer
        branch_name:
          minLength: 1
          type: string
        checks_failed:
          format: int64
          minimum: 0
          type: integer
        checks_passed:
          format: int64
          minimum: 0
          type: integer
        checks_total:
          format: int64
          minimum: 0
          type: integer
        ci_status:
          enum:
            - pending
            - passed
            - failed
          type: string
        commits:
          format: int64
          minimum: 0
          type: integer
        deletions:
          format: int64
          minimum: 0
          type: integer
        html_url:
          minLength: 1
          type: string
        lines_changed:
          format: int64
          minimum: 0
          type: integer
        merged_at:
          minLength: 1
          type: string
        pr_number:
          format: int64
          minimum: 1
          type: integer
        pull_request_id:
          format: uuid
          type: string
        state:
          enum:
            - open
            - closed
            - merged
          type: string
        title:
          type: string
      required:
        - pull_request_id
        - pr_number
        - html_url
        - title
        - checks_passed
        - checks_failed
        - checks_total
        - commits
        - lines_changed
        - additions
        - deletions
      type: object
    TaskProjectContext:
      discriminator:
        mapping:
          active: '#/components/schemas/TaskActiveProject'
          archived: '#/components/schemas/TaskArchivedProject'
        propertyName: state
      oneOf:
        - $ref: '#/components/schemas/TaskActiveProject'
        - $ref: '#/components/schemas/TaskArchivedProject'
    RepoMcpServerSkip:
      additionalProperties: false
      properties:
        file:
          enum:
            - .mcp.json
            - .codex/config.toml
          type: string
        reason:
          description: Why the task is not given it, end-user copy.
          minLength: 1
          type: string
        server:
          description: >-
            The server as the file names it; null when the whole file is
            skipped.
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - file
        - server
        - reason
      type: object
    TaskReviewSubjectPullRequest:
      additionalProperties: false
      properties:
        additions:
          format: int64
          minimum: 0
          type: integer
        branch_name:
          minLength: 1
          type: string
        checks_failed:
          format: int64
          minimum: 0
          type: integer
        checks_passed:
          format: int64
          minimum: 0
          type: integer
        checks_total:
          format: int64
          minimum: 0
          type: integer
        ci_status:
          enum:
            - pending
            - passed
            - failed
          type: string
        commits:
          format: int64
          minimum: 0
          type: integer
        deletions:
          format: int64
          minimum: 0
          type: integer
        html_url:
          minLength: 1
          type: string
        lines_changed:
          format: int64
          minimum: 0
          type: integer
        merged_at:
          minLength: 1
          type: string
        origin_task_id:
          format: uuid
          type: string
        pr_number:
          format: int64
          minimum: 1
          type: integer
        pull_request_id:
          format: uuid
          type: string
        review_check_conclusion:
          enum:
            - success
            - failure
            - cancelled
            - neutral
          type: string
        review_trigger:
          enum:
            - automatic
            - comment_command
            - manual
          type: string
        state:
          enum:
            - open
            - closed
            - merged
          type: string
        title:
          type: string
      required:
        - pull_request_id
        - pr_number
        - html_url
        - title
        - checks_passed
        - checks_failed
        - checks_total
        - commits
        - lines_changed
        - additions
        - deletions
        - review_trigger
      type: object
    TaskRunContext:
      additionalProperties: false
      properties:
        started_at:
          minLength: 1
          type: string
        workspace_id:
          minLength: 1
          type: string
      required:
        - workspace_id
        - started_at
      type: object
    TaskRuntimeInterval:
      additionalProperties: false
      properties:
        cpu_kind:
          enum:
            - shared
            - performance
          type:
            - string
            - 'null'
        cpus:
          format: int64
          minimum: 0
          type:
            - integer
            - 'null'
        end_reason:
          enum:
            - halted
            - terminated
          type:
            - string
            - 'null'
        ended_at:
          minLength: 1
          type:
            - string
            - 'null'
        gpu_kind:
          enum:
            - a10
            - l40s
            - a100-40gb
            - a100-80gb
          type:
            - string
            - 'null'
        id:
          minLength: 1
          type: string
        machine_id:
          minLength: 1
          type: string
        memory_mb:
          format: int64
          minimum: 0
          type:
            - integer
            - 'null'
        started_at:
          minLength: 1
          type: string
        task_id:
          minLength: 1
          type: string
        volume_size_gb:
          format: int64
          minimum: 0
          type:
            - integer
            - 'null'
        workspace_id:
          minLength: 1
          type:
            - string
            - 'null'
      required:
        - id
        - task_id
        - machine_id
        - started_at
      type: object
    TaskRuntimeTiming:
      discriminator:
        mapping:
          active: '#/components/schemas/TaskRuntimeTimingActive'
          inactive: '#/components/schemas/TaskRuntimeTimingInactive'
        propertyName: state
      oneOf:
        - $ref: '#/components/schemas/TaskRuntimeTimingInactive'
        - $ref: '#/components/schemas/TaskRuntimeTimingActive'
    TaskSlashCommand:
      additionalProperties: true
      properties:
        description:
          type: string
        input:
          additionalProperties: true
          properties:
            hint:
              type: string
          required:
            - hint
          type: object
        name:
          type: string
      required:
        - name
        - description
      type: object
    TaskSource:
      enum:
        - manual
        - web
        - mobile
        - cli
        - ci
        - sentry
        - linear
        - slack
        - automation
        - pr_review
        - teleport
        - agent
        - delegation
      type: string
    TaskUsage:
      additionalProperties: false
      properties:
        tokens_in:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        tokens_out:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        vm_uptime_seconds:
          format: int64
          minimum: 0
          type: integer
      required:
        - tokens_in
        - tokens_out
        - vm_uptime_seconds
      type: object
    TaskFailure:
      additionalProperties: false
      properties:
        org_id:
          format: uuid
          type: string
        reason:
          $ref: '#/components/schemas/TaskFailureReason'
      required:
        - reason
        - org_id
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object
    TaskAwaitingInputMessage:
      additionalProperties: false
      properties:
        kind:
          enum:
            - message
          type: string
      required:
        - kind
      type: object
    TaskAwaitingInputPlan:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/ProposePlanToolInput'
        kind:
          enum:
            - plan
          type: string
        tool_id:
          minLength: 1
          type: string
      required:
        - kind
        - tool_id
        - input
      type: object
    TaskAwaitingInputQuestions:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/AskUserToolInput'
        kind:
          enum:
            - questions
          type: string
        tool_id:
          minLength: 1
          type: string
      required:
        - kind
        - tool_id
        - input
      type: object
    TaskMcpCatalogServer:
      additionalProperties: false
      properties:
        display_name:
          minLength: 1
          type: string
        key:
          minLength: 1
          type: string
        source:
          enum:
            - catalog
          type: string
      required:
        - key
        - display_name
        - source
      type: object
    TaskMcpRepoServer:
      additionalProperties: false
      properties:
        display_name:
          minLength: 1
          type: string
        key:
          minLength: 1
          type: string
        repo_file:
          enum:
            - .mcp.json
            - .codex/config.toml
          type: string
        source:
          enum:
            - repo
          type: string
      required:
        - key
        - display_name
        - source
        - repo_file
      type: object
    TaskPlanStep:
      additionalProperties: false
      properties:
        active_form:
          minLength: 1
          pattern: \S
          type: string
        checks:
          items:
            $ref: '#/components/schemas/TaskPlanStepCheck'
          type: array
        content:
          minLength: 1
          pattern: \S
          type: string
        status:
          enum:
            - pending
            - in_progress
            - completed
          type: string
        turns:
          anyOf:
            - $ref: '#/components/schemas/TaskPlanStepTurns'
            - type: 'null'
      required:
        - content
        - status
        - turns
        - checks
      type: object
    ReviewRunStatus:
      enum:
        - reviewing
        - completed
        - failed
        - cancelled
        - superseded
        - archived
      type: string
    PRReviewSeverityCounts:
      additionalProperties: false
      properties:
        confirmed:
          format: int64
          minimum: 0
          type: integer
        nit:
          format: int64
          minimum: 0
          type: integer
        p1:
          format: int64
          minimum: 0
          type: integer
        p2:
          format: int64
          minimum: 0
          type: integer
        question:
          format: int64
          minimum: 0
          type: integer
      required:
        - p1
        - p2
        - nit
        - question
        - confirmed
      type: object
    PRReviewSummarySeverity:
      enum:
        - p1
        - p2
        - nit
      type: string
    PRReviewSummaryVerdict:
      enum:
        - APPROVE
        - REQUEST_CHANGES
        - COMMENT
        - DISMISSED
        - SUPERSEDED
      type: string
    TaskActiveProject:
      additionalProperties: false
      properties:
        installation_id:
          format: int64
          maximum: 9007199254740991
          minimum: 1
          type:
            - integer
            - 'null'
        name:
          minLength: 1
          pattern: \S
          type: string
        repo_url:
          minLength: 1
          pattern: \S
          type:
            - string
            - 'null'
        state:
          enum:
            - active
          type: string
      required:
        - state
        - name
        - repo_url
        - installation_id
      type: object
    TaskArchivedProject:
      additionalProperties: false
      properties:
        state:
          enum:
            - archived
          type: string
      required:
        - state
      type: object
    TaskRuntimeTimingActive:
      additionalProperties: false
      properties:
        active_started_at:
          minLength: 1
          type: string
        state:
          enum:
            - active
          type: string
      required:
        - state
        - active_started_at
      type: object
    TaskRuntimeTimingInactive:
      additionalProperties: false
      properties:
        state:
          enum:
            - inactive
          type: string
      required:
        - state
      type: object
    TaskFailureReason:
      enum:
        - inference_balance_empty
        - runtime_credits_exhausted
      type: string
    ProposePlanToolInput:
      additionalProperties: true
      properties:
        plan:
          type: string
        summary:
          type: string
      required:
        - summary
        - plan
      type: object
    AskUserToolInput:
      additionalProperties: true
      properties:
        questions:
          items:
            $ref: '#/components/schemas/AskUserQuestion'
          minItems: 1
          type: array
      required:
        - questions
      type: object
    TaskPlanStepCheck:
      additionalProperties: false
      properties:
        kind:
          enum:
            - tests
            - typecheck
            - lint
            - browser_check
            - preview_session
          type: string
        outcome:
          enum:
            - passed
            - failed
          type: string
      required:
        - kind
        - outcome
      type: object
    TaskPlanStepTurns:
      additionalProperties: false
      properties:
        first:
          format: int64
          minimum: 1
          type: integer
        last:
          format: int64
          minimum: 1
          type: integer
      required:
        - first
        - last
      type: object
    AskUserQuestion:
      additionalProperties: false
      properties:
        header:
          type: string
        id:
          type: string
        multiSelect:
          type:
            - boolean
            - 'null'
        options:
          items:
            $ref: '#/components/schemas/AskUserQuestionOption'
          type: array
        question:
          minLength: 1
          pattern: \S
          type: string
      required:
        - question
        - options
      type: object
    AskUserQuestionOption:
      additionalProperties: false
      properties:
        description:
          type: string
        label:
          minLength: 1
          pattern: \S
          type: string
        preview:
          type: string
      required:
        - label
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.